import ClientGame;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

// *****************************************************************************
//		Client
// *****************************************************************************

// E' l'applet di DOMINO per essere utilizzato e' necessario inserire 
// in un file .html le seguenti righe di comando :
//
//	<APPLET CODE="Client.class" WIDTH=420 HEIGHT=90>
//	<param name=check value="ON">
//	<parem name=port  value="4444">
//	</APPLET>
// 
// WIDTH e HEIGHT definiscono la dimensione della finestra in cui caricare 
// l'applet.
// 
// port="4444" indica il numero di porta 
//
// check="ON" abilita il Client a verificare le mosse prima di inviarle
// al server, se check non e definito oppure e definito diverso da "ON"
// tale funzione viene disabilitata.  
// 
// Dopo aver inserito il proprio nome e' possibile richiedere al server
// di giocare


public class Client extends java.applet.Applet implements ActionListener {


  boolean 	check;			

	// Se '==true' il Client prima di inviare una mossa al Server
	// ne verifica la correttezza

  int		port;			// Numero di porta

  Button	bEnter;			// Pulsante per creare la Connessione
  TextField	tName;			// Campo per l'immissione del nome

  private Frame		ErrFrame;	// Frame per Output messaggi importanti
  private Button	bErrOk;
  private Label		lErr;

  Image		Img[];			// Immagini GIF dei pezzi


  public void init() {

	// Viene eseguito automaticamente quando l'applet viene caricato

    check = false;			// Imposta 'check'
    if ( getParameter("check") != null )
      check = getParameter("check").equals("ON");
 
    port = 4444;
    if ( getParameter("port") !=null )
      try { 
        port = Integer.valueOf( getParameter("port") ).intValue();
      } catch ( NumberFormatException e) {
	port = 4444;
      }

    Img = new Image[14];		// Carica le immagini
    for ( int i = 0 ; i<7 ; i++ ) {
      Img[i] = getImage(getCodeBase(),"image/bw"+i+".gif");
      Img[i+7] = getImage(getCodeBase(),"image/bj"+i+".gif");
    }   
    if ( Img[0] == null ) System.exit(1);

	// Definisce l'aspetto dell'Applet

    setLayout( new FlowLayout() );
    add( new Label("    Enter your Name    "));
    tName  = new TextField("",45);
    add( tName ); 
    bEnter = new Button("Enter");
    add( bEnter );
    bEnter.addActionListener(this);

	// Crea frame per output messaggi

    ErrFrame = new Frame("Error Windows");
    ErrFrame.setSize(420,140);
    ErrFrame.setResizable( false );
    ErrFrame.setLayout( new GridLayout(2,0,0,0) ); 
    Font font= new Font("MY",Font.PLAIN,14);

    Panel pnl3 = new Panel();   
    pnl3.setLayout( new FlowLayout() );
    ErrFrame.add(pnl3);
    lErr = new Label();
    lErr.setFont( font );
    pnl3.add(lErr);

    Panel pnl4 = new Panel();   
    pnl4.setLayout( new FlowLayout() );
    ErrFrame.add(pnl4);
    bErrOk  = new Button("  Ok  ");
    bErrOk.setFont( font );
    pnl4.add( bErrOk );
    bErrOk.addActionListener(this);
    ErrFrame.setVisible( false );

  }


  public void actionPerformed(ActionEvent e ) {

	// Gestisce gli eventi del MOUSE

    String cmd = e.getActionCommand();

	// Pulsante ENTER

    if (  cmd.equals(bEnter.getLabel()) ) {
      if ( tName.getText().equals("") ) {	// Il nome e' definito non correttamnete
        lErr.setText("Name not defined");
        ErrFrame.setVisible(true);
        return;
      }  
      try {					// Richiesta di Giocare
        new ClientGame( tName.getText(), check,
 			getDocumentBase().getHost() ,port,Img );
      } catch ( IOException err ) {		// Errore creazione Socket
        lErr.setText("The Server is DOWN");
        ErrFrame.setVisible(true);
      }
	// Pulsante ErrFrame.Ok

    } else if ( cmd.equals(bErrOk.getLabel()) ) ErrFrame.setVisible(false); 

  } 


}
        
    
