import java.awt.Point;
import ClientFrame;

// *****************************************************************************
//              MoveState
// *****************************************************************************

// Memorizza lo stato della mossa.
// Nel client vi  un unica istanza di questa classe.
// Tale istanza viene creata in ClientFrame, un suo puntatore viene passato 
// alle due classi che gestiscono graficamente la scelta del pezzo e la sua 
// disposizione nel tavolo. 
// Tale istanza  condivisa fra ClientFrame, cnvIOMap, cnvIOBlock.
// cnvIOMap e cnvIOBlock ne modificano il valore in modo coerente con le scelte
// del giocatore. ClientFrame ne legge il valore quando il giocatore preme il
// tasto move e lo comiica alla classe ClientGame che ne verificher la corettezza.
// In questo modo la classe cnvIOMap pu conoscere il pezzo che il giocatore ha 
// intenzione di muovere e lo pu visualizzaro nel tavolo di gioco ancora prima
// che la mossa sia effettuata.


class MoveState {

  private ClientFrame clientframe;

  public int numplayer;

	// Numero giocatore

  public Point block;

	// Pezzo selezionato, "null" se il giocatore ha finito i pezzi

  public Point point;
 
        // Posizione del tavolo su cui muovere scelta dal giocatore

  public int   mode;

	// Modo con cui posizionare il pezzo scelto dal giocatore


  public MoveState(ClientFrame clientframe, int numplayer) {

	// Inizializza lo stato della Mossa

    this.clientframe = clientframe;
    this.numplayer = numplayer;
    block=new Point(0,0);
    point=new Point(0,0);
    mode=1;
 
  }


  public void paint() {

	// Richiamando questo metodo viene ridisegnato tutto il tavolo
	// di gioco

    clientframe.paint();

  }

}  // class  