import ParserString;

// ********************************************************************************
//				Parser
// ********************************************************************************

// Questa classe definisce un interprete di comandi 


class Parser {

  private int numComm;
  private String dataComm[]; 

	// Definizione interprete di comandi

  private String Command;

	// Comando da analizzare

  private int typeComm;

	// Tipo di Comando
	//       -1 		Comando Sconosciuto
	//       -2 		Formato parametri non validi
 	//  0..numComm-1	Comando corretto, numero di comando

  private int Par;
 
	// Numero di parametri del comando

  final int numPar = 10;
  private String dataPar[] = new String[numPar];
  private int    typePar[] = new int[numPar];

	// 'numpar'  Numero Massimo di Parametri
	// 'datapar' Valore dei parametri
	// 'typepar' Tipo dei parametri 
	//   1 : Integer
	//   2 : String
 

  public Parser( String dataComm[] , int numComm) {

	// Costruttore, definisce il parser

    this.numComm = numComm;
    this.dataComm = new String[numComm];
 
    for ( int i=0 ; i<numComm ; i++ )
      this.dataComm[i] = new String( dataComm[i] );
  
    typeComm = -1;    
    Par = 0;
  }


  public int setCommand( String Command ) {

	// Analizza il comando 'Command'
	// Restituisce :
	//       -1 		Comando Sconosciuto
	//       -2 		Formato parametri non validi
 	//  0..numComm-1	Comando corretto, numero di comando


    if ( Command == null ) {
      typeComm=-1;
      Command = null;
      return typeComm;
    }  
       
    this.Command = new String(Command);

    ParserString Commi = new ParserString(Command);

    String str;
    int j;       

	// Identifica il tipo di Comando    

    typeComm = -1;
    str = Commi.subUD(" ");

	// 'str' Caratteri precedenti a " "
	// 'commi' Caratteri posteriori a " "

    for ( int i=0 ; ( i<numComm ) && ( typeComm==-1 ) ; i++ ) {
      j = dataComm[i].indexOf(" ");
      if (j==-1) j=dataComm[i].length();
      if ( str.equals( dataComm[i].substring(0,j) ) ) typeComm=i;
    }
    if ( typeComm==-1 ) return typeComm;

	// Verifico i Parametri
    
    ParserString Commc = new ParserString( dataComm[typeComm]);
    Commc.subUD(" ");

	// 'commc' formato del comando specificato

    for ( Par=0 ; (!(Commi.isEmpty())) && (!(Commc.isEmpty())) && (Par<=numPar) ; Par++) {

      dataPar[Par]=Commi.subUD(",");

	// 'dataPar[par]' Caratteri precedenti a   ","
	// 'commi'	  Caratteri posteriori a   ","

      str = Commc.subUD(",");

	// 'str'   Caratteri precedenti a  ","
	// 'Commc' Caratteri posteriori a  ","

	// Verifica del formato

      if ( str.equals("Integer") ) {		// Type 'int'
        typePar[Par]=1;
        try { 
          Integer i=Integer.valueOf( dataPar[Par]);       
        } catch ( NumberFormatException e) {
          typeComm=-2;
          return typeComm;
        }
      } else if ( str.equals("String") ) {	// type 'String'  
        typePar[Par]=2;
      }
    }

    if ( !Commi.isEmpty() || !Commc.isEmpty() ) {
      typeComm=-2;
      return typeComm;
    }
    return typeComm;
  }

                          
  public int getCommand() {

	// Restituisce :
	//       -1 		Comando Sconosciuto
	//       -2 		Formato parametri non validi
 	//  0..numComm-1	Comando corretto, numero di comando

    return typeComm;
  }


  public Integer getInteger( int Par ) {

	// Se il comando e' valido, se esiste il parametro di posizione 'Par' e
	// se e di tipo Integer ne restituisce il valore, altrimneti restituisce null

    if ( typeComm >=0 )			// Se il comando e' valido
      if ( Par <= this.Par )		  // Se esiste il parametro
        if ( typePar[Par] == 1 )	    // Se il parametro e' di tipo corretto
        return Integer.valueOf( dataPar[Par] );
    
    return null;
  }


  public String getString( int Par ) {

	// Se il comando e' valido, se esiste il parametro di posizione 'Par' e
	// se e di tipo String ne restituisce il valore, altrimneti restituisce null

    if ( typeComm >=0 )			// Se il comando e' valido
      if ( Par <= this.Par )		  // Se esiste il parametro
        if ( typePar[Par] == 2 )	    // Se il parametro e' di tipo corretto
        return new String( dataPar[Par] );
    
    return null;
  }   
    

  public String toString() {

	// Restituisce l'ultimo comando analizzato

    if ( Command != null ) return new String(Command);
    return null;
  }

} // class






      
