import java.awt.*;
import java.awt.event.*;
import Block;
import MoveState;
import cnvOBlock;

// *****************************************************************************
//		cnvIOBlock
// *****************************************************************************

// Gestisce la scelta del pezzo da muovere da parte del giocatore


class cnvIOBlock extends cnvOBlock implements  MouseListener {
 

  private Block game;

	// Puntatore privato alla classe Block, serve per conoscere i pezzi
	// posseduti dal giocatore
 
  private Point point;

	// Posizione nel tavolo dei pezzi posseduti dal giocatore del pezzo 
	// selezionato, "null" se il giocatore ha finito i pezzi

  private MoveState mst;

	// Puntatore privato allo stato della mossa scelta del giocatore


  public cnvIOBlock( Block game , MoveState mst , Image Img[] ) {

	// Costruttore, inizializza le variabili

    super( game , Img , mst.numplayer );      

    this.game = game;
    this.mst = mst;
    initPoint();
    addMouseListener(this);    
 }


  private int initPoint() {

	// Inizializza 'point' e 'block' con il primo pezzo posseduto dal giocatore
        // 'null' se il giocatore ha finito i pezzi.

    int i,j;
    point = null;

    for ( i=0 ; ( i<game.numblock ) && ( point == null ) ; i++ )
      for ( j=0 ; ( j<game.numblock ) && ( point == null ) ; j++ ) 
        if ( data[i][j] != null ) point = new Point(i,j);      

	// Il giocatore non ha finito i pezzi ?

    if ( point == null) {
      mst.block = null; 
      return -1;
    }

    mst.block.move( data[point.x][point.y].x , data[point.x][point.y].y); 
    return 0;
  }


  public void mousePressed(MouseEvent e) {

	// Imposta 'point' e 'block' a causa della pressione del mouse sul tavolo
	// dei pezzi posseduti dal giocatore

    if ( point == null ) return;

    Point msp = e.getPoint();
    Point mmp = new Point( msp.y / bsize.height , msp.x / bsize.width );

    if ( data[mmp.x][mmp.y]==null) {
      data[mmp.x][mmp.y] = data[point.x][point.y];
      data[point.x][point.y] = null;
    }
    point.move(mmp.x,mmp.y);
    mst.block.move(data[point.x][point.y].x , data[point.x][point.y].y);  
    mst.paint();
  } 


  public void mouseClicked(MouseEvent e) {};	// Eventi non definiti
  public void mouseReleased(MouseEvent e) {};
  public void mouseEntered(MouseEvent e) {};
  public void mouseExited(MouseEvent e) {};


  public void paint(Graphics g) {  
     
	// Evidenzia il pezzo selezionato dal giocatore

    super.paint(g);

    if ( point == null ) return;
    if ( data[point.x][point.y] == null ) {
      data[point.x][point.y] = null;
      if ( initPoint() < 0) return;
    }      

    g.drawImage(Img[mst.block.x+7], bsize.width*point.y, bsize.height*point.x, 
                                fsize.width,         fsize.height, this);
    g.drawImage(Img[mst.block.y+7], bsize.width*point.y+fsize.width, bsize.height*point.x, 
                                    fsize.width,                     fsize.height, this);

//  g.setColor(Color.red);
//  g.drawRect( bsize.width*point.y, bsize.height*point.x , 
//              2*fsize.width,       fsize.height);  
  }

}  // class
