import java.awt.*;
import java.awt.event.*;
import Map;
import MoveState;
import cnvOMap;

// *****************************************************************************
//		cnvIOMap
// *****************************************************************************

// Gestisce la scelta da parte del giocatore della posizione del Tavolo su cui 
// muovere.


class cnvIOMap extends cnvOMap implements  MouseListener {

  private Map game;

	// Puntatore alla classe Map, serve per conoscere la disposizione dei pessi
	// posizionati sul Tavolo

  private MoveState mst;

	// Puntatore privato allo stato della mossa scelta dal giocatore

public cnvIOMap( Map game , MoveState mst ,Image Img[] ) {

	// Costruttore, inizializza le variabili

    super( game , Img );      
    
    this.game = game; 
    this.mst=mst;
    addMouseListener(this);
 }


  public void mousePressed(MouseEvent e) {

	// Imposta 'point' e 'mode' a causa della pressione del mouse sul tavolo
	// dei pezzi posizionati

    Point msp = e.getPoint();
    Point mmp = new Point( msp.y / fsize.height , msp.x / fsize.width );

    mst.point.move(mmp.x,mmp.y );

    mmp.move( msp.y % fsize.height , msp.x % fsize.width );

    double ds[] = { 0 ,0 , 0 , 0 };
    ds[0] = ( 0              - mmp.x ) * ( 0              - mmp.x ) + 
            ( fsize.width/2  - mmp.y ) * ( fsize.width/2  - mmp.y );
    ds[1] = ( fsize.height/2 - mmp.x ) * ( fsize.height/2 - mmp.x ) + 
            ( fsize.width    - mmp.y ) * ( fsize.width    - mmp.y );
    ds[2] = ( fsize.height   - mmp.x ) * ( fsize.height   - mmp.x ) + 
            ( fsize.width/2  - mmp.y ) * ( fsize.width/2  - mmp.y );
    ds[3] = ( fsize.height/2 - mmp.x ) * ( fsize.height/2 - mmp.x ) + 
            ( 0              - mmp.y ) * ( 0              - mmp.y );

    int m=0;
    for ( int i=1 ; i<4 ; i++ )  if  ( ds[i]<ds[m] ) m=i;

    mst.mode=m;

    repaint();
  } 


  public void mouseClicked(MouseEvent e) {};	// Eventi non definiti
  public void mouseReleased(MouseEvent e) {};
  public void mouseEntered(MouseEvent e) {};
  public void mouseExited(MouseEvent e) {};

      
  public void paint(Graphics g) {

	// Evidenzia la posizione sul tavolo selezionata dal giocatore

    super.paint( g );

    Point mp = new Point( game.modetype[mst.mode][0],
                          game.modetype[mst.mode][1]);
    g.setColor(Color.red);

    if (mst.block == null) return;
    int chk=game.check(mst.numplayer, mst.block, mst.point, mst.mode);

    if (chk>=0) {	// Mossa valida
      Point pt;
      if (chk>10) pt=new Point(mst.block.y,mst.block.x);
      else        pt=new Point(mst.block.x,mst.block.y); 
      g.drawImage(Img[pt.x+7], fsize.width*mst.point.y, fsize.height*mst.point.x,
   			     fsize.width,             fsize.height, this);
      g.drawImage(Img[pt.y+7], fsize.width*(mst.point.y+mp.y), fsize.height*(mst.point.x+mp.x),
                             fsize.width,                    fsize.height, this);
    } else {  		// Mossa non valida
      g.drawRect( fsize.width*mst.point.y, fsize.height*mst.point.x,
                  fsize.width, 		 fsize.height); 
      g.drawRect( fsize.width*(mst.point.y+mp.y), fsize.height*(mst.point.x+mp.x),
                  fsize.width,			fsize.height);    
    }  

//    g.drawLine( fsize.width*mst.point.y     , fsize.height*mst.point.x ,
//                fsize.width*(mst.point.y+1) , fsize.height*(mst.point.x+1) ); 
//    g.drawLine( fsize.width*mst.point.y     , fsize.height*(mst.point.x+1),
//                fsize.width*(mst.point.y+1) , fsize.height*mst.point.x );    
    

 }

}  // class
