import java.awt.*;
import Block;

// *****************************************************************************
//		cnvOBlock
// *****************************************************************************

// Gestisce l'output dei pezzi posseduti dal giocatore


class cnvOBlock extends Canvas {

  private Block block;

	// Puntatore privato alla classe Block, serve per conoscere i pezzi
	// posseduti dal giocatore

  protected Image Img[];

	// Puntatore privato alle immagini GIF dei pezzi
 
  protected Point data[][];

	// L'elemento data[i][j] indica il pezzo che trova nella 
	// posizione (i,j) del tavolo. Se l'elemento e' NULL vuol
	// dire che quella posizione e' vuota.

  protected int numplaier;

	// Indica di quale giocatore si vuole l'output

  protected Dimension wsize;

	// Dimensione del Canvas

  protected Dimension fsize;

	// Dimensione della singola figura  

  protected Dimension bsize;

	// Dimensione del singolo posto su cui posizionare un pezzo


  public cnvOBlock( Block block , Image Img[] , int numplaier) {

	// Costruttore, inizializza le variabili

    super();

    this.block = block;
    this.Img = Img;     
    this.numplaier = numplaier;
    data     = new Point[ block.numblock ][ block.numblock ];

    int i,j,e;
    Point pt = new Point(0,0);

	// Inizializza la struttura 'data'

    for ( i=0 ; i<block.numblock ; i++ )
      for ( j=0 ; j<=i ; j++ ) {

        pt.move(i,j); 
        
        if ( block.getBlock( pt , numplaier )==0 ) 
          data[i][j] = new Point(i,j);
      }	
 }


  private void setSize() {

	// Inizializza i parametri relativi alla dimensione della finestra

    wsize  = getSize();
    bsize = new Dimension( wsize.width / (block.numblock) , wsize.height / (block.numblock) );
    fsize = new Dimension( (int)(bsize.width*0.45) , (int)(bsize.height*0.9));
  }


  private void upBlock() {

	// Aggiorna la struttura 'data' nel caso in cui il giocatore posiziona
	// un pezzo

    int i,j;

    for ( i=0 ; i<block.numblock ; i++ )
      for ( j=0 ; j<block.numblock ; j++ )
        if ( data[i][j] != null ) 
          if ( block.getBlock( data[i][j] , numplaier ) != 0 ) 
             data[i][j] = null;
  }


  public void paint(Graphics g) {  

	// Esegue l'output dei pezzi posseduti dal giocatore 

    upBlock();

    setSize();

    g.drawRect(0,0,wsize.width-1,wsize.height-1);

    int i,j,e;
  
    for ( i=0 ; i<block.numblock ; i++ ) 
     for ( j=0 ; j<block.numblock ; j++ )  		
       if ( data[i][j] != null ) {
         g.drawImage( Img[ data[i][j].x ] , bsize.width*j , bsize.height*i , 
                                            fsize.width   , fsize.height   , this);
         g.drawImage( Img[ data[i][j].y ] , bsize.width*j+fsize.width  , bsize.height*i , 
                                            fsize.width                , fsize.height   ,this);
       }  
  }

}  // class